module.exports = function(grunt) {
	// Config
	grunt.initConfig({
		pkg: grunt.file.readJSON('package.json'),
		dirs: {
			js_src: '../include/js',
			js_dest: '../include/js',
			i18n_src: '..',
			langs: 'languages'
		},

		vars: { },

		uglify: {
			main: {
				files: {
					'<%= dirs.js_dest %>/admin.min.js' : ['<%= dirs.js_src %>/admin.js']
				}
			}
		},

		makepot: {
			target: {
				options: {
					type: 'wp-plugin',
					potFilename: 'fontmeister.pot',
					cwd: '<%= dirs.i18n_src %>',
					domainPath: '<%= dirs.langs %>'
				}
			}
		}
	});

	// Load plugins
	var cwd = process.cwd();
	process.chdir('../../../../..');
	grunt.loadNpmTasks('grunt-contrib-concat');
	grunt.loadNpmTasks('grunt-contrib-uglify');
	grunt.loadNpmTasks('grunt-wp-i18n');
	process.chdir(cwd);

	// Tasks
	grunt.registerTask('default', [
		'uglify:main',
//		'concat:main',
		'makepot:target'
	]);
};