<script type="text/javascript">
	<?php
	$source = '';
	$family = '';
	if (isset($_GET['source']) && in_array($_GET['source'], array('Typekit', 'Google Web Fonts'))) {
		$source = htmlentities($_GET['source'], ENT_NOQUOTES);
		if ($source == 'Typekit') {
			if (isset($_GET['family'])) {
				$family = htmlentities($_GET['family'], ENT_NOQUOTES);
			}

			if (isset($_GET['kit'])) {
				$kit = htmlentities($_GET['kit'], ENT_NOQUOTES);
				?>
	WebFontConfig = {
		typekit: {
			id: '<?php echo $kit; ?>'
		}
	};
	<?php
			}
		}
		else if ($source == 'Google Web Fonts') {
			if (isset($_GET['family'])) {
				$family = htmlentities($_GET['family'], ENT_NOQUOTES);
				?>
	WebFontConfig = {
		google: {
			families: ['<?php echo $family; ?>']
		}
	};
	<?php
			}
		}
		?>
	(function () {
		var wf = document.createElement('script');
		wf.src = 'https://ajax.googleapis.com/ajax/libs/webfont/1/webfont.js';
		wf.type = 'text/javascript';
		wf.async = 'true';
		var s = document.getElementsByTagName('script')[0];
		s.parentNode.insertBefore(wf, s);
	})();
	<?php
	}
	?>

	function fontmeister_bold_unbold(element) {
		var preview = document.getElementById('fm-preview-panel');
		var tags = ['h1', 'h2', 'h3', 'h4', 'h5', 'h6'];
		for (var i = 0; i < tags.length; i++) {
			var h = preview.getElementsByTagName(tags[i])[0];
			h.className = element.value;
		}
		return false;
	}

	function fontmeister_manage_size(element) {
		var preview = document.getElementById('fm-preview-panel');
		preview.className = element.value;
		return false;
	}
</script>

<?php
if ($source == 'Typekit') {
	?>
	<script type='text/javascript' src='//use.typekit.com/<?php echo $kit; ?>.js'></script>
	<script type='text/javascript'>try{Typekit.load();}catch(e){}</script>
	<?php
}
?>
<style type="text/css">
	#fm-preview-panel {
		font-family: <?php echo $family; ?>;
		font-size: 14px;
		padding: 10px;
	}
</style>

<h1 class="fm-preview-title">FontMeister Font Preview</h1>

<?php
if (isset($_GET['source']) && in_array($_GET['source'], array('Typekit', 'Google Web Fonts'))) {
	?>
	<div class="fm-preview-prelude">
		<p>
			You are previewing the &ldquo;<?php echo $family; ?>&rdquo; stack from <?php echo $source; ?>.
		</p>
		<label>
			Header text:
			<select id="fm-preview-header" onchange="fontmeister_bold_unbold(this);">
				<option value="normal">Regular</option>
				<option value="bold">Bold</option>
				<option value="thin">Thin</option>
			</select>
		</label>
		<label>
			Body font size:
			<select id="fm-preview-sizes" onchange="fontmeister_manage_size(this);">
				<option value="px-10">10px</option>
				<option value="px-11">11px</option>
				<option value="px-12">12px</option>
				<option value="px-13">13px</option>
				<option value="px-14" selected="selected">14px</option>
				<option value="px-15">15px</option>
				<option value="px-16">16px</option>
				<option value="px-17">17px</option>
				<option value="px-18">18px</option>
				<option value="px-19">19px</option>
				<option value="px-20">20px</option>
			</select>
		</label>
	</div>

	<div id="fm-preview-panel">
		<h1 class="normal">&lt;H1&gt;: Mr. Jock, TV quiz Ph.D., bags few lynx.</h1>
		<h2 class="normal">&lt;H2&gt;: Bawds jog, flick quartz, vex nymph.</h2>
		<h3 class="normal">&lt;H3&gt;: Waltz, nymph, for quick jigs vex Bud.</h3>
		<h4 class="normal">&lt;H4&gt;: Quick wafting zephyrs vex bold Jim.</h4>
		<h5 class="normal">&lt;H5&gt;: Jackadaws love my big sphinx of quartz.</h5>
		<h6 class="normal">&lt;H6&gt;: Pack my box with five dozen liquor jugs.</h6>
		<p>
			&lt;P&gt;: The quick brown fox jumps over the lazy dog. A sentence with all letters of the alphabet is called a pangram.
			The pangrams for H1 to H5 are all from Richard Lederer's book Crazy English.
		</p>
	</div>
	<?php
}
else if (isset($_GET['source']) && $_GET['source'] == 'Font Squirrel') {
	if (isset($_GET['family'])) {
		$family = htmlentities($_GET['family'], ENT_NOQUOTES);
		?>
		<div class="fm-preview-prelude">
			<p>
				You are previewing the &ldquo;<?php echo $family; ?>&rdquo; stack from <?php echo $_GET['source']; ?>.
			</p>
		</div>

		<?php
		$font_info_url = 'https://www.fontsquirrel.com/api/familyinfo/'.$family;

		$response = wp_remote_request($font_info_url);
		$response = wp_remote_retrieve_body($response);
		$variants = json_decode($response);

		if (!empty($variants) && is_array($variants)) {
			echo "<ul class='fm-font-preview-images'>\n";
			$size = '&s=14';
			$text = '&t='.urlencode("Bawds jog, flick quartz, vex nymph.");
			$scale = '&scale=150';

			foreach ($variants as $variant) {
				if (isset($variant->listing_image)) {
					echo "<li>";
					//$font = 'font='.$variant->family_id.'/'.$variant->filename;
					$font = $variant->checksum;
					//$img_url = 'http://www.fontsquirrel.com/utils/font_list_sample.php?'.$font.$size.$text.$scale;
					$img_url = 'https://www.fontsquirrel.com/fonts/ajax/test_drive/'.$font.'?'.$size.$text;

					echo "<iframe src='$img_url'></iframe>";
					echo $variant->family_name;
					if (isset($variant->style_name)) {
						echo " (".$variant->style_name.")";
					}
					echo "</li>";
				}
			}
			echo "</ul>\n";
		}
		else {
			?>
			<p>
				There seems to be a problem pulling this font from Font Squirrel. Nothing was returned by the server.
			</p>
			<?php
		}
	}
}
?>

